#include "battery_widget.h"
#include <memory>
using namespace std;
 
BatteryWidget::BatteryWidget(wxWindow* parent, wxWindowID id,
				const wxPoint& pos, const wxSize& size,
				long style, const wxString& name)
				: wxPanel(parent, id, pos, size, style, name)
{
	Connect(this->GetId(), wxEVT_PAINT, wxPaintEventHandler(BatteryWidget::OnPaint));
	Connect(this->GetId(), wxEVT_SIZE, wxSizeEventHandler(BatteryWidget::OnResize));
	border=5;
}
 
void BatteryWidget::OnPaint(wxPaintEvent& event)
{
	wxPaintDC pdc(this);
	auto_ptr<wxGraphicsContext> dc(wxGraphicsContext::Create(pdc));
	//wxGraphicsContext *dc = wxGraphicsContext::Create(
		//pdc );
 
	dc->SetBrush(wxBrush (color));
	int width, height, width_b, height_b, width_step, height_step, height_pos;
	GetClientSize(&width, &height);
	width_b = width/3;
	height_b = height/12;

	dc->DrawRectangle(width_b, 0, width_b, height_b);
	dc->DrawRectangle(0, height_b, border, height-height_b);
	dc->DrawRectangle(width-border, height_b, border, height-height_b);
	dc->DrawRectangle(0, height_b, width, border);
	dc->DrawRectangle(0, height-border, width, border);
	//const double column_width = static_cast<double>(width) / data.size();
 
	width_step=width - (border<<2);
	height_step=(height - height_b - (border*3))/steps - border;
	height_pos = height - (border<<1) - height_step;
	for(int i=0;i<steps;i++)
	{
		if(i<state) {
			dc->DrawRectangle(border<<1, height_pos, width_step, height_step);
		}
		else {
			dc->DrawRectangle(border<<1, height_pos, width_step, border);
			dc->DrawRectangle(border<<1, height_pos+height_step-border, width_step, border);
			dc->DrawRectangle(border<<1, height_pos, border, height_step);
			dc->DrawRectangle(border+width_step, height_pos, border, height_step);
		}
		height_pos-=(height_step+border);
	}

	//int i ; //= 0;
	//double item_x, item_y, item_ratio, item_height;
	//BOOST_FOREACH(double d, data) {
	/*for(i=0; i<data.size();i++) {
		item_x = i * column_width;
		item_ratio = data_total ? data[i]/data_total : 0;
		item_height = item_ratio * height;
		item_y = height-item_height;
		dc->DrawRectangle(item_x, item_y, column_width, item_height);
		//i++;
	}*/
}
 
void BatteryWidget::OnResize(wxSizeEvent& event)
{
	Refresh();
	event.Skip();
}
 
void BatteryWidget::SetData(vector<double> d)
{
	data.assign(d.begin(), d.end());
	data_total = 0;
	//BOOST_FOREACH(double tmp, data) {
	for(int i=0; i<data.size();i++) data_total += data[i];
	//}
}

void BatteryWidget::SetSteps(int s)
{
	steps=s;
	Refresh();
}

void BatteryWidget::SetState(int s)
{
	state=s;
	Refresh();
}

int BatteryWidget::GetSteps()
{
	return steps;
}

void BatteryWidget::SetState(int s, int n)
{
	state=s;
	steps=n;
	Refresh();
}

void BatteryWidget::SetBorder(int b)
{
	border=b;
	Refresh();
}

void BatteryWidget::SetColour(const wxColour& col)
{
	color = col;
	Refresh();
}
